#include "sara.h"
/* Hihi, jag tror inte Sara förstår vad dom få kommentarerna jag har betyder :D */


RENDER_TEXTURE *renderTextureNew(int w, int h, int tile_w, int tile_h) {
	RENDER_TEXTURE *tex;

	if ((tex = malloc(sizeof(RENDER_TEXTURE))) == NULL)
		return 0;
	
	tex->w = w;
	tex->h = h;
	tex->t_w = 1.0f / (w / tile_w);
	tex->t_h = 1.0f / (h / tile_h);
	tex->tile_w = w / tile_w;
	tex->tile_h = h / tile_h;

	glGenTextures(1, &tex->tex);
	glBindTexture(GL_TEXTURE_2D, tex->tex);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, w, h, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);

	return tex;
}


void renderTextureUpdate(RENDER_TEXTURE *texture, int x, int y, int w, int h, void *data) {
	glBindTexture(GL_TEXTURE_2D, texture->tex);

	glTexSubImage2D(GL_TEXTURE_2D, 0, x, y, w, h, GL_RGBA, GL_UNSIGNED_BYTE, data);

	return;
}


RENDER_TEXTURE *renderTextureDelete(RENDER_TEXTURE *texture) {
	glDeleteTextures(1, &texture->tex);
	free(texture);

	return NULL;
}


void renderCacheClearOne(QUAD_CACHE *qc, int quad) {
	RENDER_COORD coord;
	int i, j;

	coord.x = coord.y = coord.z = coord.u = coord.v = 0.0f;

	for (i = 0; i < 2; i++)
		for (j = 0; j < 3; j++)
			qc->quad[quad].tri[i].coord[j] = coord;
	qc->coord[quad].base_x = qc->coord[quad].base_y = qc->coord[quad].base_z = 0.0f;
	qc->coord[quad].off_x = qc->coord[quad].off_y = qc->coord[quad].off_z = 0.0f;
	qc->coord[quad].rot_x = qc->coord[quad].rot_y = qc->coord[quad].rot_z = 0.0f;
	renderCacheRotateOne(qc, quad, 0.0f, 0.0f, 0.0f);

	return;
}


void renderCacheSetTextureSpot(QUAD_CACHE *qc, int quad, int tile) {
	int t_x, t_y;
	float u, v, u2, v2;

	t_x = tile % qc->tex->tile_w;
	t_y = tile / qc->tex->tile_w;
	u = qc->tex->t_w * t_x;
	v = qc->tex->t_h * t_y;
	u2 = qc->tex->t_w + u;
	v2 = v + qc->tex->t_h;

	qc->quad[quad].tri[0].coord[0].u = u;
	qc->quad[quad].tri[0].coord[0].v = v;
	qc->quad[quad].tri[0].coord[1].u = u2;
	qc->quad[quad].tri[0].coord[1].v = v;
	qc->quad[quad].tri[0].coord[2].u = u2;
	qc->quad[quad].tri[0].coord[2].v = v2;
	qc->quad[quad].tri[1].coord[0].u = u2;
	qc->quad[quad].tri[1].coord[0].v = v2;
	qc->quad[quad].tri[1].coord[1].u = u;
	qc->quad[quad].tri[1].coord[1].v = v2;
	qc->quad[quad].tri[1].coord[2].u = u;
	qc->quad[quad].tri[1].coord[2].v = v;

	return;
}



void renderCacheSetOne(QUAD_CACHE *qc, int quad, float x, float y, float z, float s, int tile) {
	float t;

	t = s / 2;
	qc->coord[quad].base_x = x;
	qc->coord[quad].base_y = y;
	qc->coord[quad].base_z = z;

	qc->coord[quad].off_x = qc->coord[quad].off_y = t;
	qc->coord[quad].off_z = 0;
	renderCacheSetTextureSpot(qc, quad, tile);
	renderCacheRotateOne(qc, quad, qc->coord[quad].rot_x, qc->coord[quad].rot_y, qc->coord[quad].rot_z);

	return;
}
	


QUAD_CACHE *renderCacheAlloc(int quads, RENDER_TEXTURE *texture) {
	QUAD_CACHE *qc;
	int i;

	if ((qc = malloc(sizeof(QUAD_CACHE))) == NULL)
		return NULL;
	
	qc->quads = quads;
	qc->quad = malloc(sizeof(RENDER_QUAD) * quads);
	qc->coord = malloc(sizeof(RENDER_COORD_C) * quads);

	if (qc->quad == NULL || qc->coord == NULL) {
		free(qc->quad);
		free(qc->coord);
		free(qc);
		return NULL;
	}

	for (i = 0; i < quads; i++)
		renderCacheClearOne(qc, i);

	qc->tex = texture;

	return qc;
}


void renderCache(QUAD_CACHE *qc) {
	if (qc == NULL)
		return;
	
	glBindTexture(GL_TEXTURE_2D, qc->tex->tex);
	glVertexPointer(3, GL_FLOAT, 20, &qc->quad->tri->coord->x);
	glTexCoordPointer(2, GL_FLOAT, 20, &qc->quad->tri->coord->u);

	glDrawArrays(GL_TRIANGLES, 0, qc->quads * 6);

	return;
}


float renderCalcRotation(float rot_1, float r) {
	return r*sinf(rot_1);// + r*sinf(rot_2);
}


void renderRotate(float *x, float *y, float *z, float rot_x, float rot_y, float rot_z) {
	float x_, y_, z_;

	x_ = (*z) * sinf(rot_y) + (*x) * cosf(rot_y);
	z_ = (*z) * cosf(rot_y) - (*x) * sinf(rot_y);
	*x = x_;
	*z = z_;

	y_ = (*y) * cosf(rot_x) - (*z) * sinf(rot_x);
	z_ = (*y) * sinf(rot_x) + (*z) * cosf(rot_x);
	*y = y_;
	*z = z_;

	x_ = (*y) * sinf(rot_z) + (*x) * cosf(rot_z);
	y_ = (*y) * cosf(rot_z) - (*x) * sinf(rot_z);
	*x = x_;
	*y = y_;

	return;
}


void renderCacheRotateOne(QUAD_CACHE *qc, int quad, float rot_x, float rot_y, float rot_z) {
	float x_r, y_r, z_r, x[4], y[4], z[4];
	int i;

	if (qc == NULL)
		return;
	
	if (qc->quads <= quad)
		return;

	qc->coord[quad].rot_x = rot_x;
	qc->coord[quad].rot_y = rot_y;
	qc->coord[quad].rot_z = rot_z;
	x_r = qc->coord[quad].off_x;
	y_r = qc->coord[quad].off_y;
	z_r = qc->coord[quad].off_z;

	x[0] = x[3] = x_r * -1;
	x[1] = x[2] = x_r;
	y[0] = y[1] = y[2] = y_r;
	y[2] = y[3] = y_r * -1;
	z[0] = z[1] = z[2] = z[3] = z_r;

	for (i = 0; i < 4; i++) {
		renderRotate(&x[i], &y[i], &z[i], rot_x, rot_y, rot_z);
		y[i] *= video.h_mult;
		x[i] += qc->coord[quad].base_x;
		y[i] += qc->coord[quad].base_y;
		z[i] += qc->coord[quad].base_z;
	}

	qc->quad[quad].tri[0].coord[0].x = x[0];
	qc->quad[quad].tri[0].coord[0].y = y[0];
	qc->quad[quad].tri[0].coord[0].z = z[0];

	qc->quad[quad].tri[0].coord[1].x = x[1];
	qc->quad[quad].tri[0].coord[1].y = y[1];
	qc->quad[quad].tri[0].coord[1].z = z[1];

	qc->quad[quad].tri[0].coord[2].x = x[2];
	qc->quad[quad].tri[0].coord[2].y = y[2];
	qc->quad[quad].tri[0].coord[2].z = z[2];
	
	qc->quad[quad].tri[1].coord[1].x = x[3];
	qc->quad[quad].tri[1].coord[1].y = y[3];
	qc->quad[quad].tri[1].coord[1].z = z[3];

	qc->quad[quad].tri[1].coord[0] = qc->quad[quad].tri[0].coord[2];
	qc->quad[quad].tri[1].coord[2] = qc->quad[quad].tri[0].coord[0];

	return;
}
