#ifndef __RENDER_H__
#define	__RENDER_H__


typedef struct {
	float		base_x;
	float		base_y;
	float		base_z;
	
	float		off_x;
	float		off_y;
	float		off_z;

	float		rot_x;
	float		rot_y;
	float		rot_z;
} RENDER_COORD_C;


typedef struct {
	float		x;
	float		y;
	float		z;
	float		u;
	float		v;
} RENDER_COORD;


typedef struct {
	RENDER_COORD	coord[3];
} RENDER_TRI;


typedef struct {
	RENDER_TRI	tri[2];
} RENDER_QUAD;


typedef struct {
	unsigned int	tex;
	int		w;
	int		h;
	int		tile_w;
	int		tile_h;
	float		t_w;
	float		t_h;
} RENDER_TEXTURE;


typedef struct {
	RENDER_TEXTURE	*tex;
	RENDER_QUAD	*quad;
	RENDER_COORD_C	*coord;
	int		quads;
} QUAD_CACHE;


RENDER_TEXTURE *renderTextureNew(int w, int h, int tile_w, int tile_h);
void renderTextureUpdate(RENDER_TEXTURE *texture, int x, int y, int w, int h, void *data);
RENDER_TEXTURE *renderTextureDelete(RENDER_TEXTURE *texture);
void renderCacheClearOne(QUAD_CACHE *qc, int quad);
void renderCacheSetTextureSpot(QUAD_CACHE *qc, int quad, int tile);
void renderCacheSetOne(QUAD_CACHE *qc, int quad, float x, float y, float z, float s, int tile);
QUAD_CACHE *renderCacheAlloc(int quads, RENDER_TEXTURE *texture);
void renderCache(QUAD_CACHE *qc);
void renderCacheRotateOne(QUAD_CACHE *qc, int quad, float rot_x, float rot_y, float rot_z);



#endif
