#include <stdio.h>
#include <stdlib.h>

#include <SDL/SDL_image.h>

int main(int argc, char **argv) {
	FILE *out;
	SDL_Surface *image;
	int i;
	unsigned int *pixels;

	if (argc <3) {
		fprintf(stderr, "Usage: %s <image> <output binary>\n", argv[0]);
		return -1;
	}

	if ((image = IMG_Load(argv[1])) == NULL) {
		fprintf(stderr, "Unable to open %s\n", argv[1]);
		return -1;
	}

	if ((out = fopen(argv[2], "wb+")) == NULL) {
		fprintf(stderr, "Unable to write %s\n", argv[2]);
		return -1;
	}

	if (!image->format->Amask) {
		fprintf(stderr, "Alpha channel is needed!\n");
		return -1;
	}

	fwrite(&image->w, 4, 1, out);
	pixels = image->pixels;
	fwrite(pixels, image->w * image->h, 4, out);
	i = image->w * image->h * 4 + 8;
	fwrite(&i, 4, 1, out);

	fclose(out);

	return 0;
}
